﻿using Microsoft.AspNetCore.Mvc;
using Syncfusion.EJ2.Blazor;
using System;
using System.Collections.Generic;
using System.Linq;
using System.Threading.Tasks;
using AsyncGrid.Data;

namespace AsyncGrid.Controllers
{
    [Route("api/[controller]")]
    [ApiController]
    public class EmailController : ControllerBase
    {

        [HttpPost("getEmails")]
        public async Task<IActionResult> GetEmails([FromBody]DataManagerRequest dm)
        {
            await Task.Delay(100);
            IEnumerable<Email> emails = Enumerable.Range(1, 1000).Select(x => new Email()
            {
                MessageId = Guid.NewGuid(),
                Author = (new string[] { "ALFKI", "ANANTR", "ANTON", "BLONP", "BOLID" })[new Random().Next(5)],
                FromAddress = (new string[] { "ALFKI", "ANANTR", "ANTON", "BLONP", "BOLID" })[new Random().Next(5)],
                ToAddress = (new string[] { "ALFKI", "ANANTR", "ANTON", "BLONP", "BOLID" })[new Random().Next(5)],
                Subject = (new string[] { "ALFKI", "ANANTR", "ANTON", "BLONP", "BOLID" })[new Random().Next(5)],
                AttachmentGroup = (new string[] { "ALFKI", "ANANTR", "ANTON", "BLONP", "BOLID" })[new Random().Next(5)],
                CcAddress = (new string[] { "ALFKI", "ANANTR", "ANTON", "BLONP", "BOLID" })[new Random().Next(5)],
                BccAddress = (2.1 * x).ToString(),
                ReplyToAddress = (new string[] { "ALFKI", "ANANTR", "ANTON", "BLONP", "BOLID" })[new Random().Next(5)],
                CreatedDate = DateTime.Now.AddDays(-x),
            }).ToList();

            int totalCount = emails.Count();

            // Paging
            if (dm.Skip != 0)
            {
                emails = DataOperations.PerformSkip(emails, dm.Skip);
            }
            if (dm.Take != 0)
            {
                emails = DataOperations.PerformTake(emails, dm.Take);
            }


            return new JsonResult(new { result = emails.ToList(), count = totalCount });
        }
    }
}
